org.apache.solr.schema

## Class BoolField

- java.lang.Object
- - org.apache.solr.schema.FieldProperties
  - - org.apache.solr.schema.FieldType
    - - org.apache.solr.schema.PrimitiveFieldType
      - - org.apache.solr.schema.BoolField

-     public class BoolField
      extends PrimitiveFieldType

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.solr.schema.FieldType

      `FieldType.DefaultAnalyzer, FieldType.MultiValueSelector`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static Analyzer` | `boolAnalyzer`
    `protected static char[]` | `FALSE_TOKEN`
    `protected static char[]` | `TRUE_TOKEN`

    - ### Fields inherited from class org.apache.solr.schema.FieldType

      `ANALYZER, args, CHAR_FILTER, CHAR_FILTERS, CLASS_NAME, docValuesFormat, falseProperties, FILTER, FILTERS, INDEX, INDEX_ANALYZER, MULTI_TERM, MULTI_TERM_ANALYZER, POLY_FIELD_SEPARATOR, postingsFormat, properties, QUERY, QUERY_ANALYZER, similarity, SIMILARITY, similarityFactory, TOKENIZER, trueProperties, TYPE, TYPE_NAME, typeName`

    - ### Fields inherited from class org.apache.solr.schema.FieldProperties

      `BINARY, DOC_VALUES, INDEXED, MULTIVALUED, OMIT_NORMS, OMIT_POSITIONS, OMIT_TF_POSITIONS, REQUIRED, SORT_MISSING_FIRST, SORT_MISSING_LAST, STORE_OFFSETS, STORE_TERMOFFSETS, STORE_TERMPAYLOADS, STORE_TERMPOSITIONS, STORE_TERMVECTORS, STORED, TOKENIZED, USE_DOCVALUES_AS_STORED`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BoolField()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `checkSchemaField(SchemaField field)` Check's `SchemaField` instances constructed using this field type to ensure that they are valid.
    `List<IndexableField>` | `createFields(SchemaField field, Object value, float boost)` Given a `SchemaField`, create one or more `IndexableField` instances
    `Analyzer` | `getIndexAnalyzer()` Returns the Analyzer to be used when indexing fields of this type.
    `Analyzer` | `getQueryAnalyzer()` Returns the Analyzer to be used when searching fields of this type.
    `SortField` | `getSortField(SchemaField field, boolean reverse)` Returns the SortField instance that should be used to sort fields of this type.
    `UninvertingReader.Type` | `getUninversionType(SchemaField sf)` DocValues is not enabled for a field, but it's indexed, docvalues can be constructed on the fly (uninverted, aka fieldcache) on the first request to sort, facet, etc.
    `ValueSource` | `getValueSource(SchemaField field, QParser qparser)` called to get the default value source (normally, from the Lucene FieldCache.)
    `CharsRef` | `indexedToReadable(BytesRef input, CharsRefBuilder charsRef)` Given an indexed term, append the human readable representation
    `String` | `indexedToReadable(String indexedForm)` Given an indexed term, return the human readable representation
    `Object` | `marshalSortValue(Object value)` Convert a value used by the FieldComparator for this FieldType's SortField into a marshalable value for distributed sorting.
    `String` | `toExternal(IndexableField f)` Convert the stored-field format to an external (string, human readable) value
    `String` | `toInternal(String val)` Convert an external value (from XML update command or from query string) into the internal format for both storing and indexing (which can be modified by any analyzers).
    `Boolean` | `toObject(IndexableField f)` Convert the stored-field format to an external object.
    `Object` | `toObject(SchemaField sf, BytesRef term)`
    `Object` | `unmarshalSortValue(Object value)` Convert a value marshaled via `FieldType.marshalSortValue(java.lang.Object)` back into a value usable by the FieldComparator for this FieldType's SortField
    `void` | `write(TextResponseWriter writer, String name, IndexableField f)` calls back to TextResponseWriter to write the field value

    - ### Methods inherited from class org.apache.solr.schema.PrimitiveFieldType

      `init`

    - ### Methods inherited from class org.apache.solr.schema.FieldType

      `createField, createField, getAnalyzerProperties, getClassArg, getDocValuesFormat, getFieldQuery, getIndexOptions, getNamedPropertyValues, getNonFieldPropertyArgs, getNumericType, getPostingsFormat, getPrefixQuery, getRangeQuery, getRewriteMethod, getSimilarity, getSimilarityFactory, getSingleValueSource, getStringSort, getTypeName, hasProperty, isExplicitAnalyzer, isExplicitQueryAnalyzer, isMultiValued, isPolyField, isTokenized, marshalBase64SortValue, marshalStringSortValue, multiValuedFieldCache, readableToIndexed, readableToIndexed, restrictProps, setArgs, setIndexAnalyzer, setIsExplicitAnalyzer, setIsExplicitQueryAnalyzer, setQueryAnalyzer, setSimilarity, storedToIndexed, storedToReadable, supportsAnalyzers, toNativeType, toString, unmarshalBase64SortValue, unmarshalStringSortValue, useDocValuesAsStored`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### TRUE_TOKEN

          protected static final char[] TRUE_TOKEN

    - #### FALSE_TOKEN

          protected static final char[] FALSE_TOKEN

    - #### boolAnalyzer

          protected static final Analyzer boolAnalyzer

  - ### Constructor Detail

    - #### BoolField

          public BoolField()

  - ### Method Detail

    - #### getSortField

          public SortField getSortField(SchemaField field,
                                        boolean reverse)

      Description copied from class: `FieldType`
      Returns the SortField instance that should be used to sort fields of this type.
      Specified by:
        `getSortField` in class `FieldType`
      See Also:
        `SchemaField.checkSortability()`

    - #### getUninversionType

          public UninvertingReader.Type getUninversionType(SchemaField sf)

      Description copied from class: `FieldType`
      DocValues is not enabled for a field, but it's indexed, docvalues can be constructed on the fly (uninverted, aka fieldcache) on the first request to sort, facet, etc. This specifies the structure to use.
      Specified by:
        `getUninversionType` in class `FieldType`
      Parameters:
        `sf` - field instance
      Returns:
        type to uninvert, or `null` (to disallow uninversion for the field)

    - #### getValueSource

          public ValueSource getValueSource(SchemaField field,
                                            QParser qparser)

      Description copied from class: `FieldType`
      called to get the default value source (normally, from the Lucene FieldCache.)
      Overrides:
        `getValueSource` in class `FieldType`

    - #### getIndexAnalyzer

          public Analyzer getIndexAnalyzer()

      Description copied from class: `FieldType`
      Returns the Analyzer to be used when indexing fields of this type.

      This method may be called many times, at any time.

      Overrides:
        `getIndexAnalyzer` in class `FieldType`
      See Also:
        `FieldType.getQueryAnalyzer()`

    - #### getQueryAnalyzer

          public Analyzer getQueryAnalyzer()

      Description copied from class: `FieldType`
      Returns the Analyzer to be used when searching fields of this type.

      This method may be called many times, at any time.

      Overrides:
        `getQueryAnalyzer` in class `FieldType`
      See Also:
        `FieldType.getIndexAnalyzer()`

    - #### toInternal

          public String toInternal(String val)

      Description copied from class: `FieldType`
      Convert an external value (from XML update command or from query string) into the internal format for both storing and indexing (which can be modified by any analyzers).
      Overrides:
        `toInternal` in class `FieldType`
      See Also:
        `FieldType.toExternal(org.apache.lucene.index.IndexableField)`

    - #### toExternal

          public String toExternal(IndexableField f)

      Description copied from class: `FieldType`
      Convert the stored-field format to an external (string, human readable) value
      Overrides:
        `toExternal` in class `FieldType`
      See Also:
        `FieldType.toInternal(java.lang.String)`

    - #### toObject

          public Boolean toObject(IndexableField f)

      Description copied from class: `FieldType`
      Convert the stored-field format to an external object.
      Overrides:
        `toObject` in class `FieldType`
      See Also:
        `FieldType.toInternal(java.lang.String)`

    - #### toObject

          public Object toObject(SchemaField sf,
                                 BytesRef term)

      Overrides:
        `toObject` in class `FieldType`

    - #### indexedToReadable

          public String indexedToReadable(String indexedForm)

      Description copied from class: `FieldType`
      Given an indexed term, return the human readable representation
      Overrides:
        `indexedToReadable` in class `FieldType`

    - #### indexedToReadable

          public CharsRef indexedToReadable(BytesRef input,
                                            CharsRefBuilder charsRef)

      Description copied from class: `FieldType`
      Given an indexed term, append the human readable representation
      Overrides:
        `indexedToReadable` in class `FieldType`

    - #### write

          public void write(TextResponseWriter writer,
                            String name,
                            IndexableField f)
                     throws IOException

      Description copied from class: `FieldType`
      calls back to TextResponseWriter to write the field value
      Specified by:
        `write` in class `FieldType`
      Throws:
        `IOException`

    - #### marshalSortValue

          public Object marshalSortValue(Object value)

      Description copied from class: `FieldType`
      Convert a value used by the FieldComparator for this FieldType's SortField into a marshalable value for distributed sorting.
      Overrides:
        `marshalSortValue` in class `FieldType`

    - #### unmarshalSortValue

          public Object unmarshalSortValue(Object value)

      Description copied from class: `FieldType`
      Convert a value marshaled via `FieldType.marshalSortValue(java.lang.Object)` back into a value usable by the FieldComparator for this FieldType's SortField
      Overrides:
        `unmarshalSortValue` in class `FieldType`

    - #### createFields

          public List<IndexableField> createFields(SchemaField field,
                                                   Object value,
                                                   float boost)

      Description copied from class: `FieldType`
      Given a `SchemaField`, create one or more `IndexableField` instances
      Overrides:
        `createFields` in class `FieldType`
      Parameters:
        `field` - the `SchemaField`
        `value` - The value to add to the field
        `boost` - The boost to apply
      Returns:
        An array of `IndexableField`
      See Also:
        `FieldType.createField(SchemaField, Object, float)`, `FieldType.isPolyField()`

    - #### checkSchemaField

          public void checkSchemaField(SchemaField field)

      Description copied from class: `FieldType`
      Check's `SchemaField` instances constructed using this field type to ensure that they are valid.

      This method is called by the `SchemaField` constructor to check that its initialization does not violate any fundemental requirements of the `FieldType`. The default implementation does nothing, but subclasses may chose to throw a `SolrException` if invariants are violated by the `SchemaField.`

      Overrides:
        `checkSchemaField` in class `FieldType`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.